//==============================================================================================================================
// Tonemapping Operator (trivial) 10.0.hlsl
// CricWood "Bieder"  Christopher Maiwald, 20082010
//		E-Mail	CricWood@NerdShack.com
//		ICQ		342 173 470
// Codepage: Windows-1252; text width: 128 chars; tab size: 4 spaces
// File comments are in English language.
//==============================================================================================================================



// Direct3D 10 / 11 difference: Direct3D 10.0 can not handle multi-sampled textures in the same, easy way Direct3D 11 can.
//	Therefor, multi-sampling is not available in the Direct3D 10 version. However, to avoid two seperate paths in the executable
//	(creating a non-multisampled 2D-texture and a TEX2D SRV vs. creating a multisampled 2D-texture and a TEX2DMS SRV), this D3D
//	10.0 shader declares a probably multi-sampled texture but uses only one of its samples.
Texture2DMS<float3, 1> g_Input	:register(t0);



cbuffer g_Constants				:register(b0) {
	float3	g_Exposure				:packoffset(c0);
};



//------------------------------------------------------------------------------------------------------------------------------
// The pixel shader.
//------------------------------------------------------------------------------------------------------------------------------
const float3 ProcessPixel(
	in const float4 ItsPosition :SV_Position
) : SV_Target0 {
	return saturate(1.0f - exp(-g_Exposure * g_Input.Load(int2(ItsPosition.xy), 0)));
}
